/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Trigger que procesa la carga de la historico de sol
                        vta especial vines

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha                Autor                       Descripcion
    1.0    29-Noviembre-2020    Héctor Figueroa            	Creación
******************************************************************************* */

public class TAM_HistFlotillasProgVines_tgr_hanler extends TriggerHandler{

    static String VaRtSolVtaEspFlot = Schema.SObjectType.TAM_SolicitudesFlotillaPrograma__c.getRecordTypeInfosByName().get('Venta Corporativa').getRecordTypeId();
    static String VaRtSolVtaEspProg = Schema.SObjectType.TAM_SolicitudesFlotillaPrograma__c.getRecordTypeInfosByName().get('Programa').getRecordTypeId();
	
	static String VaRtAccRegPMCC = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo').getRecordTypeId();
	static String VaRtAccRegPFCC = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente Corporativo CP').getRecordTypeId();
	static String VaRtCteMoralNoVigente = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral No Vigente').getRecordTypeId();
	static String VaRtCteFisicaNoVigente = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica No Vigente').getRecordTypeId();	
    static String VaRtCteFisicaMor = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral').getRecordTypeId();   
    static String VaRtCteFisicaFis = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica').getRecordTypeId();   

    static String sRectorTypePasoInventario = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Inventario').getRecordTypeId();
    static String sRectorTypePasoPedidoEspecial = Schema.SObjectType.TAM_DetalleOrdenCompra__c.getRecordTypeInfosByName().get('Pedido Especial').getRecordTypeId();

    static String sRectorTypeFlotVin = Schema.SObjectType.TAM_VinesFlotillaPrograma__c.getRecordTypeInfosByName().get('Flotilla').getRecordTypeId();
    static String sRectorTypeProgVin = Schema.SObjectType.TAM_VinesFlotillaPrograma__c.getRecordTypeInfosByName().get('Programa').getRecordTypeId();

    static String sRectorTypeCheckFlotEsp = Schema.SObjectType.TAM_CheckOutDetalleSolicitudCompra__c .getRecordTypeInfosByName().get('Flotilla (Pedido Especial)').getRecordTypeId();
    static String sRectorTypeCheckProgProg = Schema.SObjectType.TAM_CheckOutDetalleSolicitudCompra__c .getRecordTypeInfosByName().get('Programa').getRecordTypeId();
    static String sRectorTypeCheckFlotEspRep = Schema.SObjectType.TAM_CheckOutDetalleSolicitudCompra__c .getRecordTypeInfosByName().get('Pedido Especial Rep').getRecordTypeId();

    private List<TAM_HistoricoFlotillasProgVines__c> itemsNew;
    private Map<Id, TAM_HistoricoFlotillasProgVines__c> mapItemsOld;    

	//Un constructor por default
	public TAM_HistFlotillasProgVines_tgr_hanler() {
        this.itemsNew = (List<TAM_HistoricoFlotillasProgVines__c>) Trigger.new;
        this.mapItemsOld = (Map<Id, TAM_HistoricoFlotillasProgVines__c>) Trigger.oldMap;		
	}

	//Sobreescribe el metodo de afterInsert
    public override void afterInsert() {
		System.debug('EN beforeInsert....');
		CreaSolicitudFlotProgVines(itemsNew);
    }

    //Sobreescribe el metodo de afterInsert
    public override void afterUpdate() {
        System.debug('EN beforeInsert....');
		CreaSolicitudFlotProgVines(itemsNew);
    }

    public void CreaSolicitudFlotProgVines(List<TAM_HistoricoFlotillasProgVines__c> itemsNew){
    
        Set<String> setIdVinActCand = new Set<String>();
        Set<String> setErroresSolUpd = new Set<String>();
        Set<String> setIdSolSucc = new Set<String>();              

        Set<String> setIdSolDetSucc = new Set<String>();              
        Set<String> setErroresSolDetUpd = new Set<String>();

        Set<String> setIdVinSolDetSucc = new Set<String>();              
        Set<String> setErroresVinSolDetUpd = new Set<String>();

        Set<String> setIdCheckVinSolDetSucc = new Set<String>();              
        Set<String> setErroresCheckVinSolDetUpd = new Set<String>();

        Set<String> setIdDODVinSolDetSucc = new Set<String>();              
        Set<String> setErroresDODVinSolDetUpd = new Set<String>();

        Set<String> setIdDODShareVinSolDetSucc = new Set<String>();              
        Set<String> setErroresDODShareVinSolDetUpd = new Set<String>();

        map<String, TAM_DetalleOrdenCompra__c> mapSolDetCreadasUps = new map<String, TAM_DetalleOrdenCompra__c>();

        map<String, String> mapRangos = new map<String, String>();
        map<String, TAM_HistoricoFlotillasProgVines__c> mapVinNomCte = new map<String, TAM_HistoricoFlotillasProgVines__c>();

        map<String, String> mapSolCreadasUps = new map<String, String>();
        map<String, TAM_SolicitudesFlotillaPrograma__c> mapHistSolFlotProgVinUps = new map<String, TAM_SolicitudesFlotillaPrograma__c>();
        map<String, TAM_SolicitudesFlotillaPrograma__c> mapSolNuevasObj = new map<String, TAM_SolicitudesFlotillaPrograma__c>();
		
		Set<String> setIdRecordype = new Set<String>{VaRtAccRegPMCC, VaRtAccRegPFCC, VaRtCteMoralNoVigente, VaRtCteFisicaNoVigente, VaRtCteFisicaMor, VaRtCteFisicaFis};
        map<String, String> mapCatalogoCentralizadoModelos = new map<String, String>();
        map<String, CatalogoCentralizadoModelos__c> mapCatalogoCentralizadoModelosIncent = new map<String, CatalogoCentralizadoModelos__c>();

		Map<String, TAM_DetalleOrdenCompra__c> mapDetalleOrdenCompraUps = new Map<String, TAM_DetalleOrdenCompra__c>();
        Map<String, TAM_VinesFlotillaPrograma__c> mapVinFlotProgUps = new Map<String, TAM_VinesFlotillaPrograma__c>();
        Map<String, TAM_CheckOutDetalleSolicitudCompra__c> mapCheckVinFlotProgUps = new Map<String, TAM_CheckOutDetalleSolicitudCompra__c>();
        Map<String, TAM_DODSolicitudesPedidoEspecial__c> mapDODVinFlotProgUps = new Map<String, TAM_DODSolicitudesPedidoEspecial__c>();
        List<TAM_DODSolicitudesPedidoEspecial__Share> lColaboraDODFlotillaPrograma = new List<TAM_DODSolicitudesPedidoEspecial__Share>();
        List<TAM_PoliticasIncentivos__c> listPoliticasCat = new List<TAM_PoliticasIncentivos__c>();
        Map<String, List<TAM_DetallePolitica__c>> mapDetPolitica = new Map<String, List<TAM_DetallePolitica__c>>();

        Set<String> setVinesHist = new Set<String>();
        Set<String> setRangoHist = new Set<String>();
        Map<String, DateTime> mapVinesVtas = new map<String, DateTime>();
        Map<String, String> mapIdGrupoNombre = new Map<String, String>();
        
        //Un Objero para el error en caso de exista
        TAM_LogsErrores__c error = new TAM_LogsErrores__c(
                TAM_Proceso__c = 'Carga Histórico Sol Flot Prog',
                TAM_Fecha__c = Date.today()    
        );

        //Consulta los grupos asociados a setPropVin
        for (Group grupoPublico : [Select g.Name, g.Id From Group g
                where Name LIKE '%DOD Seguimiento%']){
             mapIdGrupoNombre.put(grupoPublico.Name, grupoPublico.id);
        }

        //Comsulta los rangos del catalogo de Rangos__c
        for (Rangos__c rango : [Select id, Name From Rangos__c]){
            mapRangos.put(rango.Name, rango.id);
        }
        System.debug('EN actualizaDatosLead mapRangos: ' + mapRangos.KeySet());         
        System.debug('EN actualizaDatosLead mapRangos: ' + mapRangos.Values());         

        //Recorre la lista de reg que se estan nsertando
        for(TAM_HistoricoFlotillasProgVines__c histSolFltProgVin : itemsNew){
            String sRangoId = mapRangos.containsKey(histSolFltProgVin.Rango__c) ? mapRangos.get(histSolFltProgVin.Rango__c) : null;
            if (sRangoId != null)
                setRangoHist.add(sRangoId);    
        }//Fin del for para itemsNew
        System.debug('EN actualizaDatosLead setRangoHist: ' + setRangoHist);         

        //Consulta los modelos del catalogo centralizado
        for (CatalogoCentralizadoModelos__c ccm: [SELECT id, Name, CodigoColorExterior__c, CodigoColorInterior__c,
            AnioModelo__c, Modelo__c, Marca__c, serie__c, Version__c, DescripcionColorExterior__c,
            DescripcionColorInterior__c FROM CatalogoCentralizadoModelos__c Where CodigoColorExterior__c  != null ]) {
            String sName = ccm.AnioModelo__c + '-' + ccm.Modelo__c + '-' + ccm.CodigoColorExterior__c + '-' + ccm.CodigoColorInterior__c;                
            //System.debug('EN actualizaDatosLead sName0: ' + sName);
            //Agregalo al mapa de mapCatalogoCentralizadoModelos
            mapCatalogoCentralizadoModelos.put(sName, ccm.id);
            mapCatalogoCentralizadoModelosIncent.put(sName, ccm);
        }
        System.debug('EN actualizaDatosLead mapCatalogoCentralizadoModelos: ' + mapCatalogoCentralizadoModelos.KeySet());         
        System.debug('EN actualizaDatosLead mapCatalogoCentralizadoModelos: ' + mapCatalogoCentralizadoModelos.Values());         

        //Consulta las politicas de incentivos para las solicitudes especiales que se estan cargando del hit
        for (TAM_PoliticasIncentivos__c politica : [Select t.id, t.TAM_InicioVigencia__c, t.TAM_FinVigencia__c, t.TAM_EstatusIncentivos__c 
            From TAM_PoliticasIncentivos__c t Where 
            t.TAM_EstatusIncentivos__c IN ('Vigente','Vencida') And 
            t.RecordType.Name = 'Venta Corporativa' Order by t.TAM_InicioVigencia__c DESC]){
            //Agregalo al mapa de listPoliticasCat
            listPoliticasCat.add(politica);
        }
        System.debug('EN actualizaDatosLead listPoliticasCat: ' + listPoliticasCat);         

        //Consulta las politicas de incentivos para las solicitudes especiales que se estan cargando del hit
        for (TAM_DetallePolitica__c politicasCorp : [Select t.id, t.TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c, 
            t.TAM_PoliticaIncentivos__r.TAM_FinVigencia__c, t.TAM_PoliticaIncentivos__r.TAM_EstatusIncentivos__c, 
            t.Name, TAM_Rango__c, t.TAM_Clave__c, t.TAM_AnioModelo__c, t.TAM_Consecutivo__c, t.TAM_PoliticaIncentivos__c,
            t.TAM_IncPropuesto_Porcentaje__c, t.TAM_IncentivoTMEX_Porcentaje__c, t.TAM_IncDealer_Porcentaje__c,
            t.TAM_IncPropuesto_Cash__c, t.TAM_IncentivoTMEX_Cash__c, t.TAM_IncDealer_Cash__c  
            From TAM_DetallePolitica__c t Where t.TAM_PoliticaIncentivos__r.TAM_EstatusIncentivos__c IN ('Vigente')
            And t.TAM_PoliticaIncentivos__r.RecordType.Name = 'Venta Corporativa' And TAM_Rango__c IN :setRangoHist
            Order by Name, t.TAM_Consecutivo__c]){
            String sIdExterno = politicasCorp.Name;
            System.debug('EN TAM_CheckOutController politicasCorp '+ politicasCorp);
            //Metelo al mapa de mapDetPolitica
            if (mapDetPolitica.containsKey(sIdExterno))
               mapDetPolitica.get(sIdExterno).add(politicasCorp);
            if (!mapDetPolitica.containsKey(sIdExterno))
               mapDetPolitica.put(sIdExterno, new List<TAM_DetallePolitica__c>{politicasCorp});
        }
        System.debug('EN actualizaDatosLead mapDetPolitica: ' + mapDetPolitica.KeySet());         
        System.debug('EN actualizaDatosLead mapDetPolitica: ' + mapDetPolitica.Values());         
        		
        //Recorre la lista de reg que se estan nsertando
        for(TAM_HistoricoFlotillasProgVines__c histSolFltProgVin : itemsNew){
        	//Toma los datos y crea la solcitud en base al campo de Name
        	TAM_SolicitudesFlotillaPrograma__c onjNuevaSol = new TAM_SolicitudesFlotillaPrograma__c();
        	onjNuevaSol.TAM_NoVCHistorico__c = histSolFltProgVin.No_VC_Upsert__c;
        	onjNuevaSol.TAM_FechaCierreSolicitud__c = histSolFltProgVin.Fecha_de_Aprobacion__c;
        	onjNuevaSol.TAM_NombreClienteCompleto__c = histSolFltProgVin.Nombre_Cliente_Corporativo__c;
        	onjNuevaSol.TAM_NombreCompletoDistribuidor__c = histSolFltProgVin.Clave_Dealer__c;
        	onjNuevaSol.TAM_NomDistribuidorPropietario__c = histSolFltProgVin.Nombre_Dealer__c;
        	onjNuevaSol.TAM_ProgramaRango__c = mapRangos.containsKey(histSolFltProgVin.Rango__c) ? mapRangos.get(histSolFltProgVin.Rango__c) : null;
        	onjNuevaSol.TAM_Cliente__c = histSolFltProgVin.Nombre_Cliente_Corporativo__c != null ? getIdCliente(histSolFltProgVin.Nombre_Cliente_Corporativo__c, setIdRecordype) : null;
        	onjNuevaSol.TAM_Estatus__c = 'Cerrada';
        	//Solo si no act el checkout
        	if (!histSolFltProgVin.TAM_ActSoloCheckOut__c || Test.isRunningTest())
        	   //Agregala a la lista de mapHistSolFlotProgVinUps
        	   mapHistSolFlotProgVinUps.put(histSolFltProgVin.No_VC_Upsert__c, onjNuevaSol);
        	if (histSolFltProgVin.VIN__c != null)
        	   setVinesHist.add(histSolFltProgVin.VIN__c);
        }
        
        System.debug('EN actualizaDatosLead mapVinNomCte: ' + mapHistSolFlotProgVinUps.KeySet());         
        System.debug('EN actualizaDatosLead mapVinNomCte: ' + mapHistSolFlotProgVinUps.Values()); 
        System.debug('EN actualizaDatosLead setVinesHist: ' + setVinesHist); 

        //Consulta los vines asociados a setVinesHist en Ventas__c
        for (Vehiculo__c ventas : [Select v.id, v.Fecha_de_Venta__c, v.Name From Vehiculo__c v
            Where Name IN :setVinesHist]){
            //Agregalo al mapa de mapVinesVtas
            mapVinesVtas.put(ventas.Name, ventas.Fecha_de_Venta__c);
        }
        System.debug('EN actualizaDatosLead mapVinesVtas: ' + mapVinesVtas.KeySet());         
        System.debug('EN actualizaDatosLead mapVinesVtas: ' + mapVinesVtas.Values()); 
	
		//Un Save Para hacer un rollback
		Savepoint sp = Database.setSavepoint();
		Try{
			
			//Actualiza la solicitus utilizando el campo de No_VC_Upsert__c	
	        List<Database.Upsertresult> lDtbUpsResSol = Database.upsert(mapHistSolFlotProgVinUps.values(), TAM_SolicitudesFlotillaPrograma__c.TAM_NoVCHistorico__c, false);
	        //Ve si hubo error
	        for (Database.Upsertresult objDtbUpsRes : lDtbUpsResSol){
	            if (!objDtbUpsRes.isSuccess())
	               setErroresSolUpd.add('En Lead : hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
	            if (objDtbUpsRes.isSuccess())
	               setIdSolSucc.add(objDtbUpsRes.getId());
	        }//Fin del for para lDtbUpsResSol              
	        System.debug('EN actualizaDatosLead setErroresSolUpd: ' + setErroresSolUpd);         
	        System.debug('EN actualizaDatosLead setIdSolSucc: ' + setIdSolSucc); 
	
			//Cosulta los datos de las solicitudes recien creadas
			for (TAM_SolicitudesFlotillaPrograma__c objSolFlotPrgInv : [Select id, Name, TAM_NoVCHistorico__c, TAM_Cliente__c,
			     TAM_FechaCierreSolicitud__c, TAM_NombreClienteCompleto__c, TAM_NombreCompletoDistribuidor__c,
			     TAM_NomDistribuidorPropietario__c, TAM_ProgramaRango__c, TAM_Cliente__r.Name  
			     From TAM_SolicitudesFlotillaPrograma__c Where id IN: setIdSolSucc]){
				 mapSolCreadasUps.put(objSolFlotPrgInv.TAM_NoVCHistorico__c, objSolFlotPrgInv.id);
				 mapSolNuevasObj.put(objSolFlotPrgInv.TAM_NoVCHistorico__c, objSolFlotPrgInv);
			}
	        System.debug('EN actualizaDatosLead mapSolCreadasUps: ' + mapSolCreadasUps.KeySet());         
	        System.debug('EN actualizaDatosLead mapSolCreadasUps: ' + mapSolCreadasUps.Values()); 
            System.debug('EN actualizaDatosLead mapSolNuevasObj: ' + mapSolNuevasObj.KeySet());         
            System.debug('EN actualizaDatosLead mapSolNuevasObj: ' + mapSolNuevasObj.Values()); 
	
			//Recorre la lista de reg del historico de sol y crea el detalle
	        for(TAM_HistoricoFlotillasProgVines__c histSolFltProgVin : itemsNew){
	            String sColorPaso = histSolFltProgVin.Color__c;
                String sColorFinal = sColorPaso != null ? sColorPaso.replace('/', '-') : sColorPaso;	            
                String sCtaCentMod = histSolFltProgVin.Anio__c + '-' +  histSolFltProgVin.Codigo__c + '-' + sColorFinal; //histSolFltProgVin.Color__c.replace('/', '-');
	            String sName = histSolFltProgVin.Anio__c + '-' + histSolFltProgVin.Modelo__c + '-' + histSolFltProgVin.Codigo__c + '-' + sColorFinal; //histSolFltProgVin.Color__c.replace('/', '-');
	            String sIdExterno = mapSolCreadasUps.get(histSolFltProgVin.No_VC_Upsert__c) + '-' + sName + '-' + sRectorTypeFlotVin;  
                System.debug('EN actualizaDatosLead sName2: ' + sName + ' sColorFinal: ' + sColorFinal + ' sIdExterno: ' + sIdExterno + ' sCtaCentMod: ' + sCtaCentMod); 

	            //Crea el detalle de la solicitud
	            TAM_DetalleOrdenCompra__c objDetSolPaso = new TAM_DetalleOrdenCompra__c(
	                   Name = sName, TAM_SolicitudFlotillaPrograma__c = mapSolCreadasUps.get(histSolFltProgVin.No_VC_Upsert__c),
	                   TAM_EstatusEntrega__c = 'Entregado', TAM_EstatusDealerSolicitud__c = 'Cerrada', 
	                   TAM_EntregarEnMiDistribuidora__c = false, TAM_Cantidad__c = 1, RecordTypeId = sRectorTypePasoInventario,
	                   TAM_CatalogoCentralizadoModelos__c = mapCatalogoCentralizadoModelos.containsKey(sCtaCentMod) ? mapCatalogoCentralizadoModelos.get(sCtaCentMod) : NULL,
	                   TAM_IdExterno__c = sIdExterno
	            );
                System.debug('EN actualizaDatosLead objDetSolPaso: ' + objDetSolPaso); 
                //Solo si no act el checkout
                if (!histSolFltProgVin.TAM_ActSoloCheckOut__c || Test.isRunningTest())
	               //Agregalo al mapa de mapDetalleOrdenCompraUps
	               mapDetalleOrdenCompraUps.put(sIdExterno, objDetSolPaso);	               
	        }        
	        System.debug('EN actualizaDatosLead mapVinNomCte: ' + mapDetalleOrdenCompraUps.KeySet());         
	        System.debug('EN actualizaDatosLead mapVinNomCte: ' + mapDetalleOrdenCompraUps.Values()); 
			
            //Actualiza la solicitus utilizando el campo de No_VC_Upsert__c 
            List<Database.Upsertresult> lDtbUpsResDet = Database.upsert(mapDetalleOrdenCompraUps.values(), TAM_DetalleOrdenCompra__c.TAM_IdExterno__c, false);
            //Ve si hubo error
            for (Database.Upsertresult objDtbUpsRes : lDtbUpsResDet){
                if (!objDtbUpsRes.isSuccess())
                   setErroresSolDetUpd.add('En TAM_DetalleOrdenCompra__c : hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                if (objDtbUpsRes.isSuccess())
                   setIdSolDetSucc.add(objDtbUpsRes.getId());
            }//Fin del for para lDtbUpsResDet              
            System.debug('EN actualizaDatosLead setErroresSolDetUpd: ' + setErroresSolDetUpd);         
            System.debug('EN actualizaDatosLead setIdSolDetSucc: ' + setIdSolDetSucc); 
			
			//Cosulta los registros del detalle que acabamos de insertar
			for (TAM_DetalleOrdenCompra__c objDetaSol : [Select id, TAM_SolicitudFlotillaPrograma__c, TAM_IdExterno__c
			     From TAM_DetalleOrdenCompra__c Where Id IN: setIdSolDetSucc ]){
			    mapSolDetCreadasUps.put(objDetaSol.TAM_IdExterno__c, objDetaSol);
			}
            System.debug('EN actualizaDatosLead mapSolDetCreadasUps: ' + mapSolDetCreadasUps.KeySet());         
            System.debug('EN actualizaDatosLead mapSolDetCreadasUps: ' + mapSolDetCreadasUps.Values()); 
			
            //Recorre la lista de reg del historico de sol y crea el reg de vines Flot Prog
            for(TAM_HistoricoFlotillasProgVines__c histSolFltProgVin : itemsNew){
                String sColorPaso = histSolFltProgVin.Color__c;
                String sColorFinal = sColorPaso != null ? sColorPaso.replace('/', '-') : sColorPaso;              
                String sName = histSolFltProgVin.Anio__c + '-' + histSolFltProgVin.Modelo__c + '-' + histSolFltProgVin.Codigo__c + '-' + sColorFinal; //histSolFltProgVin.Color__c.replace('/', '-');
                String sIdExtDetFlotProd = mapSolCreadasUps.get(histSolFltProgVin.No_VC_Upsert__c) + '-' + sName + '-' + sRectorTypeFlotVin;  
                String sIdExtVinFlotProg = mapSolCreadasUps.get(histSolFltProgVin.No_VC_Upsert__c) + '-' + sName + '-' + histSolFltProgVin.VIN__c + '-' + VaRtSolVtaEspFlot;  
                System.debug('EN actualizaDatosLead sName3: ' + sName + ' sColorFinal: ' + sColorFinal + ' sIdExtDetFlotProd: ' + sIdExtDetFlotProd + ' sIdExtVinFlotProg; ' + sIdExtVinFlotProg); 
                
                //Crea el detalle de la solicitud
                TAM_VinesFlotillaPrograma__c objCinSolFltProgPaso = new TAM_VinesFlotillaPrograma__c(
                       Name = histSolFltProgVin.VIN__c, TAM_NoDistribuidor__c = histSolFltProgVin.Clave_Dealer__c,
                       TAM_Estatus__c = 'Aceptada', TAM_EstatusInventario__c = 'Piso', RecordTypeId = sRectorTypeFlotVin,
                       TAM_DetalleSolicitudCompra__c = mapSolDetCreadasUps.containsKey(sIdExtDetFlotProd) ? mapSolDetCreadasUps.get(sIdExtDetFlotProd).id : null,  
                       TAM_SolicitudFlotillaPrograma__c = mapSolDetCreadasUps.containsKey(sIdExtDetFlotProd) ? mapSolDetCreadasUps.get(sIdExtDetFlotProd).TAM_SolicitudFlotillaPrograma__c : null,  
                       TAM_IdExterno__c = sIdExtVinFlotProg
                );
                System.debug('EN actualizaDatosLead objCinSolFltProgPaso: ' + objCinSolFltProgPaso); 
                                
                //Solo si no act el checkout
                if (!histSolFltProgVin.TAM_ActSoloCheckOut__c || Test.isRunningTest())                                
                    //Si el campo de Tipo es igual a Producir no creamos el detalle en este objeto   
                    if (histSolFltProgVin.Tipo__c != 'Producir')
                        mapVinFlotProgUps.put(sIdExtVinFlotProg, objCinSolFltProgPaso);                   

            }        
            System.debug('EN actualizaDatosLead mapVinFlotProgUps: ' + mapVinFlotProgUps.KeySet());         
            System.debug('EN actualizaDatosLead mapVinFlotProgUps: ' + mapVinFlotProgUps.Values()); 

            //Actualiza la solicitus utilizando el campo de No_VC_Upsert__c 
            List<Database.Upsertresult> lDtbUpsVinResDet = Database.upsert(mapVinFlotProgUps.values(), TAM_VinesFlotillaPrograma__c.TAM_IdExterno__c, false);
            //Ve si hubo error
            for (Database.Upsertresult objDtbUpsRes : lDtbUpsVinResDet){
                if (!objDtbUpsRes.isSuccess())
                   setErroresVinSolDetUpd.add('En TAM_VinesFlotillaPrograma__c : hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                if (objDtbUpsRes.isSuccess())
                   setIdVinSolDetSucc.add(objDtbUpsRes.getId());
            }//Fin del for para lDtbUpsVinResDet              
            System.debug('EN actualizaDatosLead setErroresVinSolDetUpd: ' + setErroresVinSolDetUpd);         
            System.debug('EN actualizaDatosLead setIdVinSolDetSucc: ' + setIdVinSolDetSucc); 

            //Recorre la lista de reg del historico de sol y crea el reg de vines Flot Prog
            for(TAM_HistoricoFlotillasProgVines__c histSolFltProgVin : itemsNew){
                String[] sNo_VC_Upsert = histSolFltProgVin.No_VC_Upsert__c.split('-');
                
                String sColorPaso = histSolFltProgVin.Color__c;
                String sColorFinal = sColorPaso != null ? sColorPaso.replace('/', '-') : sColorPaso;              
                String sCtaCentMod = '';
                if (!histSolFltProgVin.TAM_ActSoloCheckOut__c )
                    sCtaCentMod = histSolFltProgVin.Anio__c + '-' +  histSolFltProgVin.Codigo__c + '-' + sColorFinal; //histSolFltProgVin.Color__c.replace('/', '-');
                if (histSolFltProgVin.TAM_ActSoloCheckOut__c )
                    sCtaCentMod = sNo_VC_Upsert[1] + '-' +  sNo_VC_Upsert[3] + '-' + sNo_VC_Upsert[4] + '-' + sNo_VC_Upsert[5]; //histSolFltProgVin.Color__c.replace('/', '-');
                
                String sName = histSolFltProgVin.Anio__c + '-' + histSolFltProgVin.Modelo__c + '-' + histSolFltProgVin.Codigo__c + '-' + sColorFinal; //histSolFltProgVin.Color__c.replace('/', '-');
                String sIdExtDetFlotProd = mapSolCreadasUps.get(histSolFltProgVin.No_VC_Upsert__c) + '-' + sName + '-' + sRectorTypeFlotVin;  
                String sIdExtCheckVinFlotProg = mapSolCreadasUps.get(histSolFltProgVin.No_VC_Upsert__c) + '-' + sName + '-' + sRectorTypePasoInventario + '-' + sRectorTypeCheckFlotEsp + '-' + (histSolFltProgVin.Tipo__c != 'Producir' ? histSolFltProgVin.VIN__c : 'Contado') ;  
                String sDescuentoPaso = histSolFltProgVin.Descuento__c != null ? histSolFltProgVin.Descuento__c : '0.00';
                String sDescuentoFinal = sDescuentoPaso.contains('%') ? sDescuentoPaso.replace('%','').replace(' ','') : sDescuentoPaso.replace(' ', '');   
                //Crea el ID Externo para la conultar el descuento en caso de que exista
                String sIdExterno = mapCatalogoCentralizadoModelosIncent.containsKey(sCtaCentMod) ? 
                    mapCatalogoCentralizadoModelosIncent.get(sCtaCentMod).AnioModelo__c + '-' : '-';
                sIdExterno += mapCatalogoCentralizadoModelosIncent.containsKey(sCtaCentMod) ? 
                    mapCatalogoCentralizadoModelosIncent.get(sCtaCentMod).Serie__c + '-' : '-';
                sIdExterno += mapCatalogoCentralizadoModelosIncent.containsKey(sCtaCentMod) ? 
                    mapCatalogoCentralizadoModelosIncent.get(sCtaCentMod).Modelo__c + '-' : '-';      
                sIdExterno += mapCatalogoCentralizadoModelosIncent.containsKey(sCtaCentMod) ? 
                    mapCatalogoCentralizadoModelosIncent.get(sCtaCentMod).Version__c : '';
                System.debug('EN actualizaDatosLead sNo_VC_Upsert: ' + sNo_VC_Upsert + ' sCtaCentMod: ' + sCtaCentMod + ' sIdExterno: ' + sIdExterno);                              
                
                //Obten el id de la politica vigente de acuerdo a la fecha de cirre de la solicitud    
                String sIdPolVigente = getPoliticaIncentivos(histSolFltProgVin.Fecha_de_Aprobacion__c, listPoliticasCat);
                //Llama a la función obtenDescuentoPolitica(sIdExterno) 
                TAM_DetallePolitica__c objDescuentoPolitica = histSolFltProgVin.Tipo__c != 'Producir' ? obtenDescuentoPolitica(sIdExterno, mapDetPolitica, sIdPolVigente, histSolFltProgVin.Rango__c, mapRangos) : new TAM_DetallePolitica__c();
                System.debug('EN actualizaDatosLead sIdExterno: ' + sIdExterno + ' objDescuentoPolitica: ' + objDescuentoPolitica);                              
                System.debug('EN actualizaDatosLead sName4 Final: ' + sName + ' sColorFinal: ' + sColorFinal + ' sIdExtDetFlotProd: ' + sIdExtDetFlotProd + ' sIdExtCheckVinFlotProg; ' + sIdExtCheckVinFlotProg + ' histSolFltProgVin.Descuento__c: ' + sDescuentoFinal + ' sCtaCentMod: ' + sCtaCentMod); 

                String sIdExternoFinal = !histSolFltProgVin.TAM_ActSoloCheckOut__c ? sIdExtCheckVinFlotProg : histSolFltProgVin.No_VC_Upsert__c;
                System.debug('EN actualizaDatosLead sIdExternoFinal: ' + sIdExternoFinal + ' sCtaCentMod: ' + sCtaCentMod); 
                
                //Crea el detalle de la solicitud
                TAM_CheckOutDetalleSolicitudCompra__c objCheckSolFltProgPaso = new TAM_CheckOutDetalleSolicitudCompra__c (
                       TAM_IdExterno__c = sIdExternoFinal, 
                       RecordTypeId = sRectorTypeCheckFlotEspRep,

	                   Name = histSolFltProgVin.Tipo__c != 'Producir' ? histSolFltProgVin.VIN__c : sName, 
                       TAM_VIN__c = histSolFltProgVin.Tipo__c != 'Producir' ? histSolFltProgVin.VIN__c : null, 
                       TAM_TipoVenta__c = histSolFltProgVin.Tipo__c != 'Producir' ? 'Inventario' : 'Pedido Especial', 
                       TAM_SolicitudFlotillaPrograma__c = mapSolDetCreadasUps.containsKey(sIdExtDetFlotProd) ? mapSolDetCreadasUps.get(sIdExtDetFlotProd).TAM_SolicitudFlotillaPrograma__c : null,  
                       TAM_TipoPago__c = histSolFltProgVin.Tipo__c != 'Producir' ? histSolFltProgVin.Pago__c : 'Contado',

                       TAM_EstatusDOD__c  = 'Asignado',                        
                       TAM_EstatusDealerSolicitud__c = 'Autorizado',
                                                       
                       TAM_EstatusEntrega__c = 'Entregado', 
                       TAM_EntregarEnMiDistribuidora__c = true,
                       TAM_EntregadoDealer__c = true, 
                       TAM_FechaEntregaDealer__c = null,

                       TAM_Cantidad__c = 1, 
                       TAM_FechaVentaDD__c = mapVinesVtas.containsKey(histSolFltProgVin.VIN__c) ? mapVinesVtas.get(histSolFltProgVin.VIN__c) : null,
                       TAM_Historico__c = true,

                       TAM_PoliticaIncentivos__c = !Test.isRunningTest() ? ( objDescuentoPolitica.TAM_IncPropuesto_Porcentaje__c != null ? objDescuentoPolitica.TAM_PoliticaIncentivos__c : getPoliticaIncentivos(histSolFltProgVin.Fecha_de_Aprobacion__c, listPoliticasCat) ): null,                       

                       TAM_CatalogoCentralizadoModelos__c = mapCatalogoCentralizadoModelos.containsKey(sCtaCentMod) ? mapCatalogoCentralizadoModelos.get(sCtaCentMod) : NULL,
                       TAM_PoliticaIncentivosVig__c = !Test.isRunningTest() ? ( objDescuentoPolitica.TAM_IncPropuesto_Porcentaje__c != null ? objDescuentoPolitica.TAM_PoliticaIncentivos__c : getPoliticaIncentivos(histSolFltProgVin.Fecha_de_Aprobacion__c, listPoliticasCat) ): null,
                       TAM_IncDealerPorcentajeVig__c = objDescuentoPolitica.TAM_IncPropuesto_Porcentaje__c != null ? objDescuentoPolitica.TAM_IncPropuesto_Porcentaje__c : Decimal.valueOf(sDescuentoFinal), //Decimal.valueOf(sDescuentoFinal),
                       TAM_IncentivoTMEXPorcentajeVig__c = objDescuentoPolitica.TAM_IncentivoTMEX_Porcentaje__c != null ? objDescuentoPolitica.TAM_IncentivoTMEX_Porcentaje__c : Decimal.valueOf(sDescuentoFinal) / 2, //Decimal.valueOf(sDescuentoFinal) / 2, 
                       TAM_IncPropuestoPorcentajeVig__c = objDescuentoPolitica.TAM_IncDealer_Porcentaje__c != null ? objDescuentoPolitica.TAM_IncDealer_Porcentaje__c : Decimal.valueOf(sDescuentoFinal) / 2 //Decimal.valueOf(sDescuentoFinal) / 2,
                                              
                       ,TAM_IncPropuestoPorcentaje__c = objDescuentoPolitica.TAM_IncPropuesto_Porcentaje__c != null ? objDescuentoPolitica.TAM_IncPropuesto_Porcentaje__c : Decimal.valueOf(sDescuentoFinal), //Decimal.valueOf(sDescuentoFinal),
                       TAM_IncentivoTMEXPorcentaje__c = objDescuentoPolitica.TAM_IncentivoTMEX_Porcentaje__c != null ? objDescuentoPolitica.TAM_IncentivoTMEX_Porcentaje__c : Decimal.valueOf(sDescuentoFinal) / 2, //Decimal.valueOf(sDescuentoFinal) / 2, 
                       TAM_IncDealerPorcentaje__c = objDescuentoPolitica.TAM_IncDealer_Porcentaje__c != null ? objDescuentoPolitica.TAM_IncDealer_Porcentaje__c : Decimal.valueOf(sDescuentoFinal) / 2, //Decimal.valueOf(sDescuentoFinal) / 2,
                       
                       TAM_IncPropuestoCash__c = objDescuentoPolitica.TAM_IncPropuesto_Cash__c != null ? objDescuentoPolitica.TAM_IncPropuesto_Cash__c : 0.00,
                       TAM_IncentivoTMEXCash__c = objDescuentoPolitica.TAM_IncentivoTMEX_Cash__c != null ? objDescuentoPolitica.TAM_IncentivoTMEX_Cash__c : 0.00,
                       TAM_IncDealerCash__c = objDescuentoPolitica.TAM_IncDealer_Cash__c != null ? objDescuentoPolitica.TAM_IncDealer_Cash__c : 0.00                    

                );
                System.debug('EN actualizaDatosLead objCheckSolFltProgPaso: ' + objCheckSolFltProgPaso); 
                //Agregalo al mapa de mapDetalleOrdenCompraUps
                mapCheckVinFlotProgUps.put(sIdExtCheckVinFlotProg, objCheckSolFltProgPaso);                   

            }        
            System.debug('EN actualizaDatosLead mapCheckVinFlotProgUps: ' + mapCheckVinFlotProgUps.KeySet());         
            System.debug('EN actualizaDatosLead mapCheckVinFlotProgUps: ' + mapCheckVinFlotProgUps.Values()); 

            //Actualiza la solicitus utilizando el campo de No_VC_Upsert__c 
            List<Database.Upsertresult> lDtbUpsCheckVinResDet = Database.upsert(mapCheckVinFlotProgUps.values(), TAM_CheckOutDetalleSolicitudCompra__c.TAM_IdExterno__c, false);
            //Ve si hubo error
            for (Database.Upsertresult objDtbUpsRes : lDtbUpsCheckVinResDet){
                if (!objDtbUpsRes.isSuccess())
                   setErroresCheckVinSolDetUpd.add('En TAM_CheckOutDetalleSolicitudCompra__c  : hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                if (objDtbUpsRes.isSuccess()){
                   setIdCheckVinSolDetSucc.add(objDtbUpsRes.getId());
                   //Crea el objeto del tipo error 
                   error.TAM_DetalleError__c = 'El id del Checkout: ' + objDtbUpsRes.getId();
                }
            }//Fin del for para lDtbUpsCheckVinResDet              
            System.debug('EN actualizaDatosLead setErroresCheckVinSolDetUpd: ' + setErroresCheckVinSolDetUpd);         
            System.debug('EN actualizaDatosLead setIdCheckVinSolDetSucc: ' + setIdCheckVinSolDetSucc); 

            //Recorre la lista de reg del historico de sol y crea el reg de CheckOut
            for(TAM_HistoricoFlotillasProgVines__c histSolFltProgVin : itemsNew){
                String sColorPaso = histSolFltProgVin.Color__c;
                String sColorFinal = sColorPaso != null ? sColorPaso.replace('/', '-') : sColorPaso;              
                String sCtaCentMod = histSolFltProgVin.Anio__c + '-' +  histSolFltProgVin.Codigo__c + '-' + sColorFinal; //histSolFltProgVin.Color__c.replace('/', '-');
                String sName = histSolFltProgVin.Anio__c + '-' + histSolFltProgVin.Modelo__c + '-' + histSolFltProgVin.Codigo__c + '-' + sColorFinal; //histSolFltProgVin.Color__c.replace('/', '-');
                String sIdExtDetFlotProd = mapSolCreadasUps.get(histSolFltProgVin.No_VC_Upsert__c) + '-' + sName + '-' + sRectorTypeFlotVin;  
                String sIdExtDODVinFlotProg = mapSolCreadasUps.get(histSolFltProgVin.No_VC_Upsert__c) + '-' + sName;  
                String sDescuentoPaso = histSolFltProgVin.Descuento__c != null ? histSolFltProgVin.Descuento__c : '0.00';
                String sDescuentoFinal = sDescuentoPaso.contains('%') ? sDescuentoPaso.replace('%','').replace(' ','') : sDescuentoPaso.replace(' ', '');    
                String ssIdExtDODVinFlotProgFin = '%' + sIdExtDODVinFlotProg + '%';
                Integer iCntMod = 0;
                String[] lIdExterno;
                System.debug('EN actualizaDatosLead sName4 Final: ' + sName + ' sColorFinal: ' + sColorFinal + ' sIdExtDetFlotProd: ' + sIdExtDetFlotProd + ' sIdExtDODVinFlotProg; ' + sIdExtDODVinFlotProg + ' histSolFltProgVin.Descuento__c: ' + sDescuentoFinal + ' sCtaCentMod: ' + sCtaCentMod + ' ssIdExtDODVinFlotProgFin: ' + ssIdExtDODVinFlotProgFin); 
                List<Integer> lCntCons = new List<Integer>();
                
                //Consulta los reg asociados a sIdExtDODVinFlotProg en TAM_DODSolicitudesPedidoEspecial__c y toma el ultimo que se creo
                for (TAM_DODSolicitudesPedidoEspecial__c DODFinal : [Select id, TAM_IdExterno__c From TAM_DODSolicitudesPedidoEspecial__c
                    Where TAM_IdExterno__c LIKE :ssIdExtDODVinFlotProgFin Order by CreatedDate DESC ]){
                    //Toma el TAM_IdExterno__c y separalo en guiones  
                    lIdExterno = DODFinal.TAM_IdExterno__c.split('-'); //   a241Y00001VgU6gQAF-2020-HILUX-7494-040-200-57051-TOYOTA PRUEBA
                    System.debug('EN actualizaDatosLead DODFinal.TAM_IdExterno__c: ' + DODFinal.TAM_IdExterno__c + ' lIdExterno.size(): ' + lIdExterno.size() + ' lIdExterno: ' + lIdExterno);
                    if (lIdExterno.size() > 6){
                        iCntMod = Integer.valueOf(lIdExterno[6]) + 1;    
                        lCntCons.add(Integer.valueOf(lIdExterno[6]));
                    }//Fin si lIdExterno.size() > 6
                }
                System.debug('EN actualizaDatosLead lCntCons: ' + lCntCons);
                //Ordena la lista lCntCons
                lCntCons.sort();
                if (lCntCons.size() > 0)
                    iCntMod = lCntCons.get(lCntCons.size()-1) + 1;
                System.debug('EN actualizaDatosLead iCntMod: ' + iCntMod);                
                
                //Crea el detalle de la solicitud
                TAM_DODSolicitudesPedidoEspecial__c objDODSolFltProgPaso = new TAM_DODSolicitudesPedidoEspecial__c (

                       Name = mapSolNuevasObj.containsKey(histSolFltProgVin.No_VC_Upsert__c) ? mapSolNuevasObj.get(histSolFltProgVin.No_VC_Upsert__c).Name : null, 
                       TAM_Anio__c = histSolFltProgVin.Anio__c, //Año 2020
                       TAM_Codigo__c = histSolFltProgVin.Codigo__c, // Código 5609 
                       TAM_Modelo__c = histSolFltProgVin.Modelo__c, // Modelo HIACE
                       TAM_Serie__c = histSolFltProgVin.Serie__c, // Serie 12 pasajeros
                       TAM_Color__c = histSolFltProgVin.Color__c, // Color 058/01
                       TAM_DescripcionColor__c = histSolFltProgVin.Descripcion_Color__c, //Descripción Color Blanco/Gris Obscuro 

                       TAM_Autorizacion1erNivel__c = 'Autorizado', 
                       TAM_Autorizacion2doNivel__c = 'Autorizado', 
                       TAM_CantidadProducir__c = 1, 
                       TAM_CatalogoCentralizadoModelos__c = mapCatalogoCentralizadoModelos.containsKey(sCtaCentMod) ? mapCatalogoCentralizadoModelos.get(sCtaCentMod) : NULL,

                       TAM_ClaveCorporativa__c = histSolFltProgVin.Clave_Cliente_Corporativo__c, //Clave Cliente Corporativo  C5939
                       TAM_NombreClienteCorporativo__c = histSolFltProgVin.Nombre_Cliente_Corporativo__c, //Nombre Cliente Corporativo SERVICIO DE TRANSPORTE TURISTICO EMPRESARIAL Y EJECUTIVO SC DE RL DE CV  
                       TAM_ClaveDealer__c = histSolFltProgVin.Clave_Dealer__c, //Clave Dealer 57023
                       TAM_NombreDealer__c = histSolFltProgVin.Nombre_Dealer__c, // Nombre Dealer TOYOTA TABASCO
                       TAM_NombreGrupoCorporativo__c = histSolFltProgVin.Nombre_Grupo_Corporativo__c, //Nombre Grupo Corporativo SINDICATO DE CHOFERES DE AUTOMOVILES DE ALQUILER Y SIMILARES DEL CARIBE "LAZARO CARDENAS DEL RIO"
                       TAM_ClaveGrupoCorporativo__c = histSolFltProgVin.Clave_Grupo_Corporativo__c, // Clave Grupo Corporativo G26

                       TAM_DescuentoAutorizadoDtm__c = Decimal.valueOf(sDescuentoFinal),
                       TAM_IncDealerPorcentaje__c = Decimal.valueOf(sDescuentoFinal) / 2,
                       TAM_IncentivoTMEXPorcentaje__c = Decimal.valueOf(sDescuentoFinal) / 2, 
                       
                       TAM_Entrega__c = histSolFltProgVin.Entrega__c, //Entrega 57023-TOYOTA TABASCO
                       TAM_Estatus__c = 'Pendiente',
                       TAM_FechaAprobacion__c = histSolFltProgVin.Fecha_de_Aprobacion__c, // Fecha de Aprobación 2020-02-07
                       TAM_FechaPeticion__c = histSolFltProgVin.Fecha_de_Peticion__c, // Fecha de Petición 2020-02-07
                       
                       TAM_Pago__c = 'Contado', 
                       TAM_PoliticaIncentivos__c = !Test.isRunningTest() ? getPoliticaIncentivos(histSolFltProgVin.Fecha_de_Aprobacion__c, listPoliticasCat) : null, 
                       TAM_SolicitudFlotillaPrograma__c = mapSolDetCreadasUps.containsKey(sIdExtDetFlotProd) ? mapSolDetCreadasUps.get(sIdExtDetFlotProd).TAM_SolicitudFlotillaPrograma__c : null,  
                       TAM_TipoSolicitud__c = 'Producir',
                       TAM_Tipo__c = 'Persona moral',

                       TAM_IdExterno__c = sIdExtDODVinFlotProg + '-' + iCntMod + '-' + (histSolFltProgVin.Entrega__c != null ? histSolFltProgVin.Entrega__c : ''),                       
                       TAM_Historico__c = true
                                              
                );
                System.debug('EN actualizaDatosLead objDODSolFltProgPaso: ' + objDODSolFltProgPaso); 
                /*//Solo si no act el checkout
                if (!histSolFltProgVin.TAM_ActSoloCheckOut__c || Test.isRunningTest())                
                    //Agregalo al mapa de mapDetalleOrdenCompraUps
                    if (histSolFltProgVin.Tipo__c == 'Producir' || Test.isRunningTest())                
                        mapDODVinFlotProgUps.put(sIdExtDODVinFlotProg, objDODSolFltProgPaso);                   
                */
            }        
            System.debug('EN actualizaDatosLead mapDODVinFlotProgUps: ' + mapDODVinFlotProgUps.KeySet());         
            System.debug('EN actualizaDatosLead mapDODVinFlotProgUps: ' + mapDODVinFlotProgUps.Values()); 

            //Actualiza la solicitus utilizando el campo de No_VC_Upsert__c 
            List<Database.Upsertresult> lDtbUpsDODVinResDet = Database.upsert(mapDODVinFlotProgUps.values(), TAM_DODSolicitudesPedidoEspecial__c.TAM_IdExterno__c, false);
            //Ve si hubo error
            for (Database.Upsertresult objDtbUpsRes : lDtbUpsDODVinResDet){
                if (!objDtbUpsRes.isSuccess())
                   setErroresDODVinSolDetUpd.add('En TAM_CheckOutDetalleSolicitudCompra__c  : hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                if (objDtbUpsRes.isSuccess()){
                   setIdDODVinSolDetSucc.add(objDtbUpsRes.getId());
                   //Crea la colaboración para el grupo de DOD
	               lColaboraDODFlotillaPrograma.add(new TAM_DODSolicitudesPedidoEspecial__Share (
	                    UserOrGroupId = mapIdGrupoNombre.get('DOD Seguimiento'),
	                    ParentId = objDtbUpsRes.getId(),
	                    AccessLevel = 'Edit'
	                    )
	               );
                }//Fin si objDtbUpsRes.isSuccess()
            }//Fin del for para lDtbUpsDODVinResDet              
            System.debug('EN actualizaDatosLead setErroresDODVinSolDetUpd: ' + setErroresDODVinSolDetUpd);         
            System.debug('EN actualizaDatosLead setIdDODVinSolDetSucc: ' + setIdDODVinSolDetSucc); 
            System.debug('EN actualizaDatosLead lColaboraDODFlotillaPrograma: ' + lColaboraDODFlotillaPrograma); 

            //Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
            List<Database.SaveResult> lDtbUpsRes = Database.insert(lColaboraDODFlotillaPrograma, false);
            //Ve si hubo error
            for (Database.SaveResult objDtbUpsRes : lDtbUpsRes){
                if (!objDtbUpsRes.isSuccess())
                   setErroresDODShareVinSolDetUpd.add('En lColaboraDODFlotillaPrograma  : hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
                if (objDtbUpsRes.isSuccess())
                   setIdDODShareVinSolDetSucc.add(objDtbUpsRes.getId());
            }//Fin del for para lDtbUpsRes
            System.debug('EN actualizaDatosLead setErroresDODShareVinSolDetUpd: ' + setErroresDODShareVinSolDetUpd);         
            System.debug('EN actualizaDatosLead setIdDODShareVinSolDetSucc: ' + setIdDODShareVinSolDetSucc);
		
            String sCreaDatosHistSolInv = System.Label.TAM_CreaDatosHistSolInv;
            Boolean bCreaDatosHistSolInv = Boolean.valueOf(sCreaDatosHistSolInv);
            System.debug('EN actualizaDatosLead bCreaDatosHistSolInv: ' + bCreaDatosHistSolInv);
            if (!bCreaDatosHistSolInv)
                Database.rollback(sp);
		
		}catch(Exception e){
            System.debug('Hubo un error en CreaSolicitudFlotProgVines: ' + e.getMessage() + ' Linea: ' + e.getLineNumber());
            //Inicializa el resto de los campos del error
            error.TAM_DetalleError__c = e.getMessage();
            error.TAM_NoLinea__c = String.valueOf(e.getLineNumber());            
            //Has el rollback
            Database.rollback(sp);
		}	

        System.debug('EN actualizaDatosLead error: ' + error);        
        //Crea el error
        if (error.TAM_DetalleError__c != null)
            insert error;
    
    }

	public String getIdCliente(String sNombreCteCorp, Set<String> setIdRecordype){
		System.debug('EN getIdCliente sNombreCteCorp: ' + sNombreCteCorp + ' setIdRecordype: ' + setIdRecordype);

		String sNomCteCorp;
		Set<String> setIdCte = new Set<String>();
		Account clienteUpd;
		
		//Ve si exite algo con ese nmbre del cliente y es corporativo
       	//Busca el nombre del cliente Corporativo en la base de datos
		List<List<SObject>> searchListCtaCorp = [FIND :sNombreCteCorp IN ALL FIELDS RETURNING Account(id, TAM_IdExternoNombre__c, Name, RecordTypeId Where RecordTypeId IN :setIdRecordype And TAM_Merge__c = false ORDER BY Name) LIMIT 2]; //Where RecordTypeId IN :setIdRecordype.
		System.debug('EN getIdCliente sNombreCteCorp: ' + sNombreCteCorp + ' searchListCtaCorp: ' + searchListCtaCorp + ' searchListCtaCorp.isEmpty(): ' + searchListCtaCorp.isEmpty() + ' searchListCtaCorp.size(): ' + searchListCtaCorp.size() + ' searchListCtaCorp: ' + searchListCtaCorp);
		
		//Toma los Clientes encontrados		
		 List<Account> searchAccountsCorp = (List<Account>) searchListCtaCorp[0];
		 //Ve si encontraste cuentas
		 if(!searchAccountsCorp.isEmpty()){
		     //Solo es un reg
		     if (searchAccountsCorp.size() == 1){
		        Account Cuenta = searchAccountsCorp.get(0);
                sNomCteCorp = Cuenta.id;
                //Ve si el reg es diferente de Cliente Corporativo
                if (Cuenta.RecordTypeId != VaRtAccRegPMCC && Cuenta.RecordTypeId != VaRtAccRegPFCC)
                   clienteUpd = new Account(id = Cuenta.id, TAM_ParaConvertirCteCorp__c = true); 
		     }//Fin si searchAccountsCorp.size() == 1
             //Si es mas de un reg el que se encontro
             if (searchAccountsCorp.size() > 1 || Test.isRunningTest()){             
				 //Recorre la lista de reg de las cuentas que fueron encontradas
				 for (Account Cuenta : searchAccountsCorp){
				    String sName = Cuenta.Name;
				    String sNameFinal = sName.toUpperCase();
				    if (sNameFinal == sNombreCteCorp){
	                    setIdCte.add(Cuenta.id);
	                    sNomCteCorp = Cuenta.id;
	                    //Ve si el reg es diferente de Cliente Corporativo
	                    if (Cuenta.RecordTypeId != VaRtAccRegPMCC && Cuenta.RecordTypeId != VaRtAccRegPFCC)
	                       clienteUpd = new Account(id = Cuenta.id, TAM_ParaConvertirCteCorp__c = true); 
	                    System.debug(LoggingLevel.INFO,'EN getIdCliente Cuenta.id: ' + Cuenta.id + ' sNomCteCorp: ' + sNomCteCorp);
	                    break;
				    }//Fin si 
				}//Fin del for para searchAccountsCorp
	            System.debug(LoggingLevel.INFO,'EN getIdCliente clienteUpd: ' + clienteUpd);
            }//Fin si searchAccountsCorp.size() > 1

			//Ve si se tiene que actuelizar el cliente
            if (clienteUpd != null)
                if (Test.isRunningTest())
                    update clienteUpd;	
		}//Fin si 	!searchAccountsCorp.isEmpty()

		System.debug(LoggingLevel.INFO,'EN getIdCliente sNomCteCorp: ' + sNomCteCorp);		
		return sNomCteCorp;
	}
    
    public String getPoliticaIncentivos(Date dtFechaAproba, List<TAM_PoliticasIncentivos__c> listPoliticasCat){
        System.debug('EN getIdCliente getPoliticaIncentivos: ' + dtFechaAproba);
        
        String sIdPolitica;
        TAM_PoliticasIncentivos__c objPolIni = listPoliticasCat.size() > 0 ? listPoliticasCat.get(0) : new TAM_PoliticasIncentivos__c();
        
        //Recorre las policiticas que vienen en el mapa de listPoliticasCat
        for (TAM_PoliticasIncentivos__c objPol : listPoliticasCat){
            System.debug('EN getIdCliente objPol: ' + objPol);
            //Compara la fecha de vigencia de la politica con la fecha de dtFechaAproba
            if (objPol.TAM_InicioVigencia__c <= dtFechaAproba && objPol.TAM_FinVigencia__c >= dtFechaAproba)
               sIdPolitica = objPol.id;               
        }
        System.debug('EN getIdCliente sIdPolitica0: ' + sIdPolitica);
        
        //Ve si es null el campo de sIdPolitica
        if (sIdPolitica == null)
           sIdPolitica = objPolIni.id != null ? objPolIni.id : null;               
            
        System.debug('EN getIdCliente sIdPolitica1: ' + sIdPolitica);
        return sIdPolitica;
    }    
    
    public static TAM_DetallePolitica__c obtenDescuentoPolitica(String sIdExterno, Map<String, List<TAM_DetallePolitica__c>> mapDetPolitica, String sIdPolVigente, 
        String sNameRango, Map<String, String> mapRangos){
        Decimal dDescuentoPoliticaPaso = 0.00;
        TAM_DetallePolitica__c objDetallePoliticaPaso = new TAM_DetallePolitica__c();
        
        String sIdRango = mapRangos.get(sNameRango);
        System.debug('EN obtenDescuentoPolitica sIdExterno: ' + sIdExterno + ' sIdPolVigente: ' + sIdPolVigente + ' sIdRango: ' + sIdRango);
        
        //Busca en el mapa de mapDetPolitica si existe sIdExterno
        if (mapDetPolitica.containsKey(sIdExterno)){
            //Recorre la lista de reg del mapa mapDetPolitica asociado a sIdExterno
            Decimal dDescuentoPoliticaIni = mapDetPolitica.get(sIdExterno).get(0).TAM_IncDealer_Porcentaje__c;
            objDetallePoliticaPaso = mapDetPolitica.get(sIdExterno).get(0);
            for (TAM_DetallePolitica__c objDetPol : mapDetPolitica.get(sIdExterno)){
                System.debug('EN obtenDescuentoPolitica objDetPol.TAM_PoliticaIncentivos__c: ' + objDetPol.TAM_PoliticaIncentivos__c + ' sIdPolVigente: ' + sIdPolVigente);                
                System.debug('EN obtenDescuentoPolitica objDetPol.TAM_Rango__c: ' + objDetPol.TAM_Rango__c + ' sIdRango: ' + sIdRango);
                //Ve si el TAM_PoliticaIncentivos__c es igual sIdPolVigente
                if (objDetPol.TAM_PoliticaIncentivos__c == sIdPolVigente && sIdRango == objDetPol.TAM_Rango__c){
                    if (objDetPol.TAM_IncDealer_Porcentaje__c != null){
                        objDetallePoliticaPaso = objDetPol;
                        System.debug('EN obtenDescuentoPolitica objDetPol.TAM_PoliticaIncentivos__c LA ENCONTRO: ' + objDetPol.TAM_PoliticaIncentivos__c + ' sIdPolVigente: ' + sIdPolVigente + ' objDetallePoliticaPaso: ' + objDetallePoliticaPaso);
                    }
                }
            }
        }//Fin si mapDetPolitica.containsKey(sIdExterno)
        
        System.debug('EN obtenDescuentoPolitica objDetallePoliticaPaso: ' + objDetallePoliticaPaso);
        return objDetallePoliticaPaso;    

    }
    
}